searchNodes=[{"doc":"Chameleon is a utility that converts colors from one model to another. It currently supports: Hex, RGB, CMYK, HSL, HSV, Pantone, and Keywords. Use Chameleon represents colors using Elixir structs. Create a color using one of the provided structs: iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) % Chameleon.RGB { b : 0 , g : 0 , r : 255 } Once you have a color, Chameleon can convert that color to another colorspace or format: iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) |&gt; Chameleon . convert ( Chameleon.HSV ) % Chameleon.HSV { h : 0 , s : 100 , v : 100 } iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) |&gt; Chameleon . convert ( Chameleon.Hex ) % Chameleon.Hex { hex : &quot;FF0000&quot; } Chameleon can also convert strings: iex&gt; Chameleon . convert ( &quot;#ff0000&quot; , Chameleon.RGB ) % Chameleon.RGB { b : 0 , g : 0 , r : 255 } iex&gt; Chameleon . convert ( &quot;red&quot; , Chameleon.CMYK ) % Chameleon.CMYK { c : 0 , k : 0 , m : 100 , y : 100 } If Chameleon doesn't know how to convert the color, you'll get an error: iex&gt; Chameleon . convert ( &quot;#112233&quot; , Chameleon.Pantone ) { :error , &quot;No pantone match could be found for that color value.&quot; } Adding color types Chameleon uses Elixir protocols internally to perform the conversions. This makes it possible to add support for new colorspaces and formats in your own code. To do this, first create a struct for your color: defmodule MyApp.FancyColor do @enforce_keys [ :c1 , :c2 , :c3 ] defstruct @enforce_keys def new ( c1 , c2 , c3 ) , do : % __MODULE__ { c1 : c1 , c2 : c2 , c3 : c3 } end Next, implement the color protocol. Your color can implement as many or as few color space protocols as you need. For example: defimpl Chameleon.Color.RGB do def from ( your_color_struct ) , do : MyApp.FancyColor . to_rgb ( your_color_struct ) end When Chameleon doesn't find a direct conversion from one color to another, it will attempt to convert through RGB. By supporting RGB conversions, your color type will be convertible between many color types. Of course, color conversion is frequently a lossy operation and you may want to implement more conversion modules. Caveat(s) Pantone is designed to be used on printed work only. As such, it is disingenuous to say a pantone value can be translated to a hex value since hex values will look different depending on the device displaying them. However, if you have a pantone value and want to find a device-displayable analog, this library will work.","ref":"Chameleon.html","title":"Chameleon","type":"module"},{"doc":"Handles conversion from the input color struct to the requested output color model. Examples iex&gt; input = Chameleon.Hex . new ( &quot;000000&quot; ) iex&gt; Chameleon . convert ( input , Chameleon.Color.Keyword ) % Chameleon.Keyword { keyword : &quot;black&quot; } iex&gt; input = Chameleon.Keyword . new ( &quot;black&quot; ) iex&gt; Chameleon . convert ( input , Chameleon.Color.CMYK ) % Chameleon.CMYK { c : 0 , m : 0 , y : 0 , k : 100 }","ref":"Chameleon.html#convert/2","title":"Chameleon.convert/2","type":"function"},{"doc":"","ref":"Chameleon.CMYK.html","title":"Chameleon.CMYK","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _cmyk = Chameleon.CMYK . new ( 25 , 30 , 80 , 0 ) % Chameleon.CMYK { c : 25 , m : 30 , y : 80 , k : 0 }","ref":"Chameleon.CMYK.html#new/4","title":"Chameleon.CMYK.new/4","type":"function"},{"doc":"","ref":"Chameleon.CMYK.html#t:t/0","title":"Chameleon.CMYK.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.CMYK.html","title":"Chameleon.Color.CMYK","type":"protocol"},{"doc":"","ref":"Chameleon.Color.CMYK.html#from/1","title":"Chameleon.Color.CMYK.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.CMYK.html#t:t/0","title":"Chameleon.Color.CMYK.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.HSL.html","title":"Chameleon.Color.HSL","type":"protocol"},{"doc":"","ref":"Chameleon.Color.HSL.html#from/1","title":"Chameleon.Color.HSL.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.HSL.html#t:t/0","title":"Chameleon.Color.HSL.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.HSV.html","title":"Chameleon.Color.HSV","type":"protocol"},{"doc":"","ref":"Chameleon.Color.HSV.html#from/1","title":"Chameleon.Color.HSV.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.HSV.html#t:t/0","title":"Chameleon.Color.HSV.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.Hex.html","title":"Chameleon.Color.Hex","type":"protocol"},{"doc":"","ref":"Chameleon.Color.Hex.html#from/1","title":"Chameleon.Color.Hex.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.Hex.html#t:t/0","title":"Chameleon.Color.Hex.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.Keyword.html","title":"Chameleon.Color.Keyword","type":"protocol"},{"doc":"","ref":"Chameleon.Color.Keyword.html#from/1","title":"Chameleon.Color.Keyword.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.Keyword.html#t:t/0","title":"Chameleon.Color.Keyword.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.Pantone.html","title":"Chameleon.Color.Pantone","type":"protocol"},{"doc":"","ref":"Chameleon.Color.Pantone.html#from/1","title":"Chameleon.Color.Pantone.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.Pantone.html#t:t/0","title":"Chameleon.Color.Pantone.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.RGB.html","title":"Chameleon.Color.RGB","type":"protocol"},{"doc":"","ref":"Chameleon.Color.RGB.html#from/1","title":"Chameleon.Color.RGB.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.RGB.html#t:t/0","title":"Chameleon.Color.RGB.t/0","type":"type"},{"doc":"","ref":"Chameleon.Color.RGB888.html","title":"Chameleon.Color.RGB888","type":"protocol"},{"doc":"","ref":"Chameleon.Color.RGB888.html#from/1","title":"Chameleon.Color.RGB888.from/1","type":"function"},{"doc":"","ref":"Chameleon.Color.RGB888.html#t:t/0","title":"Chameleon.Color.RGB888.t/0","type":"type"},{"doc":"","ref":"Chameleon.HSL.html","title":"Chameleon.HSL","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _hsl = Chameleon.HSL . new ( 7 , 8 , 9 ) % Chameleon.HSL { h : 7 , s : 8 , l : 9 }","ref":"Chameleon.HSL.html#new/3","title":"Chameleon.HSL.new/3","type":"function"},{"doc":"","ref":"Chameleon.HSL.html#t:t/0","title":"Chameleon.HSL.t/0","type":"type"},{"doc":"HSV (hue, saturation, value) represents colors using a cylinder where colors are sorted by angles and then adjusted via the saturation and value parameters.","ref":"Chameleon.HSV.html","title":"Chameleon.HSV","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _hsv = Chameleon.HSV . new ( 7 , 8 , 9 ) % Chameleon.HSV { h : 7 , s : 8 , v : 9 }","ref":"Chameleon.HSV.html#new/3","title":"Chameleon.HSV.new/3","type":"function"},{"doc":"","ref":"Chameleon.HSV.html#t:degrees/0","title":"Chameleon.HSV.degrees/0","type":"type"},{"doc":"","ref":"Chameleon.HSV.html#t:percent/0","title":"Chameleon.HSV.percent/0","type":"type"},{"doc":"","ref":"Chameleon.HSV.html#t:t/0","title":"Chameleon.HSV.t/0","type":"type"},{"doc":"","ref":"Chameleon.Hex.html","title":"Chameleon.Hex","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _hex = Chameleon.Hex . new ( &quot;FF0000&quot; ) % Chameleon.Hex { hex : &quot;FF0000&quot; }","ref":"Chameleon.Hex.html#new/1","title":"Chameleon.Hex.new/1","type":"function"},{"doc":"","ref":"Chameleon.Hex.html#t:t/0","title":"Chameleon.Hex.t/0","type":"type"},{"doc":"","ref":"Chameleon.Keyword.html","title":"Chameleon.Keyword","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _keyword = Chameleon.Keyword . new ( &quot;lime&quot; ) % Chameleon.Keyword { keyword : &quot;lime&quot; }","ref":"Chameleon.Keyword.html#new/1","title":"Chameleon.Keyword.new/1","type":"function"},{"doc":"","ref":"Chameleon.Keyword.html#t:t/0","title":"Chameleon.Keyword.t/0","type":"type"},{"doc":"","ref":"Chameleon.Pantone.html","title":"Chameleon.Pantone","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _pantone = Chameleon.Pantone . new ( &quot;30&quot; ) % Chameleon.Pantone { pantone : &quot;30&quot; }","ref":"Chameleon.Pantone.html#new/1","title":"Chameleon.Pantone.new/1","type":"function"},{"doc":"","ref":"Chameleon.Pantone.html#t:t/0","title":"Chameleon.Pantone.t/0","type":"type"},{"doc":"","ref":"Chameleon.RGB.html","title":"Chameleon.RGB","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _rgb = Chameleon.RGB . new ( 25 , 30 , 80 ) % Chameleon.RGB { r : 25 , g : 30 , b : 80 }","ref":"Chameleon.RGB.html#new/3","title":"Chameleon.RGB.new/3","type":"function"},{"doc":"","ref":"Chameleon.RGB.html#t:t/0","title":"Chameleon.RGB.t/0","type":"type"},{"doc":"","ref":"Chameleon.RGB888.html","title":"Chameleon.RGB888","type":"module"},{"doc":"Creates a new color struct. Examples iex&gt; _rgb888 = Chameleon.RGB888 . new ( 25 , 30 , 80 ) % Chameleon.RGB888 { r : 25 , g : 30 , b : 80 }","ref":"Chameleon.RGB888.html#new/3","title":"Chameleon.RGB888.new/3","type":"function"},{"doc":"","ref":"Chameleon.RGB888.html#t:t/0","title":"Chameleon.RGB888.t/0","type":"type"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html","title":"License","type":"extras"},{"doc":"&quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.","ref":"license.html#1-definitions","title":"License - 1. Definitions.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license","title":"License - 2. Grant of Copyright License.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license","title":"License - 3. Grant of Patent License.","type":"extras"},{"doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: You must give any other recipients of the Work or Derivative Works a copy of this License; and You must cause any modified files to carry prominent notices stating that You changed the files; and You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.","ref":"license.html#4-redistribution","title":"License - 4. Redistribution.","type":"extras"},{"doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.","ref":"license.html#5-submission-of-contributions","title":"License - 5. Submission of Contributions.","type":"extras"},{"doc":"This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.","ref":"license.html#6-trademarks","title":"License - 6. Trademarks.","type":"extras"},{"doc":"Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON- INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.","ref":"license.html#7-disclaimer-of-warranty","title":"License - 7. Disclaimer of Warranty.","type":"extras"},{"doc":"In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability","title":"License - 8. Limitation of Liability.","type":"extras"},{"doc":"While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html#9-accepting-warranty-or-additional-liability","title":"License - 9. Accepting Warranty or Additional Liability.","type":"extras"},{"doc":"Chameleon Chameleon is a utility that converts colors from one model to another. It currently supports: Hex, RGB, CMYK, HSL, HSV, Pantone, and Keywords.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Chameleon represents colors using Elixir structs. Create a color using one of the provided structs: iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) % Chameleon.RGB { b : 0 , g : 0 , r : 255 } Once you have a color, Chameleon can convert that color to another colorspace or format: iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) |&gt; Chameleon . convert ( Chameleon.HSV ) % Chameleon.HSV { h : 0 , s : 100 , v : 100 } iex&gt; Chameleon.RGB . new ( 255 , 0 , 0 ) |&gt; Chameleon . convert ( Chameleon.Hex ) % Chameleon.Hex { hex : &quot;FF0000&quot; } Chameleon can also convert strings: iex&gt; Chameleon . convert ( &quot;#ff0000&quot; , Chameleon.RGB ) % Chameleon.RGB { b : 0 , g : 0 , r : 255 } iex&gt; Chameleon . convert ( &quot;red&quot; , Chameleon.CMYK ) % Chameleon.CMYK { c : 0 , k : 0 , m : 100 , y : 100 } If Chameleon doesn't know how to convert the color, you'll get an error: iex&gt; Chameleon . convert ( &quot;#112233&quot; , Chameleon.Pantone ) { :error , &quot;No pantone match could be found for that color value.&quot; }","ref":"readme.html#use","title":"Overview - Use","type":"extras"},{"doc":"Chameleon uses Elixir protocols internally to perform the conversions. This makes it possible to add support for new colorspaces and formats in your own code. To do this, first create a struct for your color: defmodule MyApp.FancyColor do @enforce_keys [ :c1 , :c2 , :c3 ] defstruct @enforce_keys def new ( c1 , c2 , c3 ) , do : % __MODULE__ { c1 : c1 , c2 : c2 , c3 : c3 } end Next, implement the color protocol. Your color can implement as many or as few color space protocols as you need. For example: defimpl Chameleon.Color.RGB do def from ( your_color_struct ) , do : MyApp.FancyColor . to_rgb ( your_color_struct ) end When Chameleon doesn't find a direct conversion from one color to another, it will attempt to convert through RGB. By supporting RGB conversions, your color type will be convertible between many color types. Of course, color conversion is frequently a lossy operation and you may want to implement more conversion modules.","ref":"readme.html#adding-color-types","title":"Overview - Adding color types","type":"extras"},{"doc":"Pantone is designed to be used on printed work only. As such, it is disingenuous to say a pantone value can be translated to a hex value since hex values will look different depending on the device displaying them. However, if you have a pantone value and want to find a device-displayable analog, this library will work.","ref":"readme.html#caveat-s","title":"Overview - Caveat(s)","type":"extras"},{"doc":"The package can be installed by adding chameleon to your list of dependencies in mix.exs : def deps do [ { :chameleon , &quot;~&gt; 2.2.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Contributions are welcomed. Please open a pull request or file an issue with your ideas. Some ideas would be: Add a new color model for conversion Add functionality to generate complementary colors Handle errors for invalid input values","ref":"readme.html#contribution","title":"Overview - Contribution","type":"extras"},{"doc":"Copyright (c) 2017 Todd Resudek Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :/ / www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]